<?php
################################################################################
# @Name : ping.php
# @Description : test if asset is connected
# @call : ./core/asset.php
# @parameters : globalrow[ip] globalrow[ip2]
# @Author : Flox
# @Create : 19/12/2015
# @Update : 28/12/2017
# @Version : 3.1.15
################################################################################

//initialize variables 
if(!isset($_GET['server_key'])) $_GET['server_key'] = '';
if(!isset($argv[1])) $argv[1] = '';
if(!isset($argv[2])) $argv[2] = '';

//call via external script for cron 
if(!isset($rparameters['server_private_key']))
{
	//database connection
	require_once(__DIR__."/../connect.php");
	
	//load parameters table
	$query=$db->query("SELECT * FROM tparameters");
	$rparameters=$query->fetch();
	$query->closeCursor();
}

$today=date("Y-m-d");

//multi ping for update all assets last ping value
if ($argv[1]=='globalping')
{
	if($argv[2]===$rparameters['server_private_key'])
	{
		//load all assets table
		$query = $db->query("SELECT id,netbios,ip,ip2 FROM tassets WHERE disable=0 AND state='2'");
		while ($row=$query->fetch())
		{
			if ($row['ip']!=''){
				if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
				{
					echo "[WIN] ping $row[netbios] on IP1 $row[ip]:";
					$result=exec("ping -n 1 -w 1 $row[ip]");
					if((preg_match('#ms#', $result)))
					{
						echo " OK (Updating asset last ping flag) \n";
						$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$row['id'].'\'');
					} else {
						echo " KO \n";
					}
				} else { //linux case
					echo "[LINUX] ping $row[netbios] on IP1 $row[ip]:";
					$result=exec("ping -W 1 -c 1  $row[ip]");
					if((preg_match('#min#', $result)))
					{
						echo " OK (Updating asset last ping flag)\n";
						$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$row['id'].'\'');
					} else {
						echo " KO \n";
					}
				}
				sleep(1); //timeout 1 seconds to limit network trafic
			}
			if ($row['ip2']!=''){
				if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
				{
					echo "[WIN] ping $row[netbios] on IP2 $row[ip2]:";
					$result=exec("ping -n 1 -w 1 $row[ip2]");
					if((preg_match('#ms#', $result)))
					{
						echo " OK (Updating asset last ping flag)\n";
						$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$row['id'].'\'');
					} else {
						echo " KO \n";
					}
				} else { //linux case
				echo "[LINUX] ping $row[netbios] on IP2 $row[ip2]:";
					$result=exec("ping -W 1 -c 1  $row[ip2]");
					if((preg_match('#min#', $result)))
					{
						echo " OK (Updating asset last ping flag)\n";
						$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$row['id'].'\'');
					} else {
						echo " KO \n";
					}
				}
				sleep(1); //timeout 1 seconds to limit network trafic
			}
		}
		$query->closeCursor();	
	} else {echo "ERROR: Wrong server key go to system page to get your key";}
} else { //single ping from ticket with OS detection

	//switch to second ip if ip1 is null
	if($globalrow['ip']=='') {$test_ip=$globalrow['ip2'];} else {$test_ip=$globalrow['ip'];}

	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
		$result=exec("ping -n 1 -w 1 $test_ip");	
		//test result
		if((preg_match('#Minimum#', $result)))
		{
			//display wol message
			echo '<div class="alert alert-block alert-success"><center><i class="icon-exchange bigger-130 green"></i>&nbsp; '.T_('PING de').' <b>'.$test_ip.'</b> : OK <font size="1">('.$result.')</font> </center></div>';
			//update asset flag
			$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$globalrow['id'].'\'');
		} else {
			$result=mb_convert_encoding($result, "UTF-8");
			//display wol message
			echo '<div class="alert alert-danger"><i class="icon-remove"></i> <strong>'.T_('Erreur').':</strong> '.T_('PING de').' <b>'.$test_ip.'</b> : KO <font size="1">('.$result.')</font> </center></div>';
		}
		
	} else {
		$result=exec("ping -W 1 -c 1 $test_ip");
		//test result
		if((preg_match('#min#', $result)))
		{
			//display wol message
			echo '<div class="alert alert-block alert-success"><center><i class="icon-exchange bigger-130 green"></i>&nbsp; '.T_('PING de').' <b>'.$test_ip.'</b> : OK <font size="1">('.$result.')</font> </center></div>';
			//update asset flag
			$db->exec('UPDATE tassets SET date_last_ping=\''.$today.'\' WHERE id=\''.$globalrow['id'].'\'');
		} else {
			$result=mb_convert_encoding($result, "UTF-8");
			//display wol message
			echo '<div class="alert alert-danger"><i class="icon-remove"></i> <strong>'.T_('Erreur').':</strong> '.T_('PING de').' <b>'.$test_ip.'</b> : KO <font size="1">('.$result.')</font> </center></div>';
		}
	}

}
?>